NameplateReadonlyProperties:
  type: object
  properties:
    id:
      type: integer
      example: 1
    created_at:
      type: string
      description: Create time
      format: date-time
      example: "2021-12-20T18:00:10.000000Z"
    updated_at:
      type: string
      description: Update time
      format: date-time
      example: "2021-12-20T18:00:10.000000Z"
  required:
    - id
    - created_at
    - updated_at

NameplateFillableProperties:
  type: object
  properties:
    name:
      type: string
      example: Exclusively in "Ensi"!
    code:
      type: string
      example: exclusively-ensi
    background_color:
      type: string
      example: "#0000ff"
    text_color:
      type: string
      example: "#1d1d1d"
    is_active:
      type: boolean
      example: true

NameplateRequiredProperties:
  required:
    - name
    - code
    - background_color
    - text_color
    - is_active

Nameplate:
  allOf:
    - $ref: '#/NameplateReadonlyProperties'
    - $ref: '#/NameplateFillableProperties'
    - $ref: '#/NameplateRequiredProperties'

CreateNameplateRequest:
  allOf:
    - $ref: '#/NameplateFillableProperties'
    - $ref: '#/NameplateRequiredProperties'

PatchNameplateRequest:
  allOf:
    - $ref: '#/NameplateFillableProperties'

SearchNameplatesRequest:
  type: object
  properties:
    sort:
      $ref: '../../../common_schemas.yaml#/RequestBodySort'
    filter:
      type: object
      description: "Filter. See the fields available for filtering in :meta"
    include:
      $ref: '../../../common_schemas.yaml#/RequestBodyInclude'
    pagination:
      $ref: '../../../common_schemas.yaml#/RequestBodyPagination'

NameplateResponse:
  type: object
  properties:
    data:
      $ref: '#/Nameplate'
    meta:
      type: object
  required:
    - data

SearchNameplatesResponse:
  type: object
  properties:
    data:
      type: array
      items:
        $ref: '#/Nameplate'
    meta:
      type: object
      properties:
        pagination:
          $ref: '../../../common_schemas.yaml#/ResponseBodyPagination'
  required:
    - data
    - meta
